package editor;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.Hashtable;
import java.util.Vector;
import java.util.Enumeration;
/**Repr&auml;sentiert einen Sensortypen mit Schablone, Energieverbrauch und 
 *anderen Informationen
 */
public class SensorTyp {
	public static final int NULLWERT = 0;//Unsichtbare Felder haben diesen Wert
	private static final int NORMAL = 0;//Zwei Array Indizes...
	private static final int GEDREHT = 1;//um eine Verbunfdklasse zu sparen

	private String name = new String();//der Name des SensorTypen
	private long gewicht;//Das Gewicht eines Sensors dieses Typen
	private long energieVerbrauchProZeit; // Energieverbrauch pro Zeit
	private long energieVerbrauchProScan; // Energieverbrauch pro Scan
	private int[][][] schablonen = new int[1][21][21];
	// in der Mitte steht der Robbi auf den Koordinaten (0,0); relativ dazu werden dann die Kacheln angegeben, die gesehen werden

	private long sichtbereiche; //Anzahl Sichtbereiche
	private Hashtable scandauer = new Hashtable(); // hier steht zu jedem Gelnde die Scandauer
	private Hashtable durchsichtigkeit = new Hashtable();// wieder abhngig vom Gelnde
	private static Vector sensoren = new Vector();//Sensoren

        /**Erzeugt einen neuen Sesortypen
         *@param name der Name des Sensortypen
         *@param sichtbereiche die Anzahl der von diesem Sensor verwendeten 
         *       Sichtbereiche
         */
	public SensorTyp(String name, int sichtbereiche) {
		this.name = name;
		this.sichtbereiche = sichtbereiche;
		sensoren.add(this);
	}

        /**Erzeugt einen neuen Sensortypen
         *@param name der Name des Sensortypen
         *@param gewicht das Gewicht eines Sensors dieses Typen
         *@param energieverbraucha der Energieverbrauch pro Zeit
         *@param energieverbrauchb der Energieverbrauch pro Scan
         *@param sichtbereiche Die Anzahl der von diesem Sensor verwendeten
         *       Sichtbereiche
         */
	public SensorTyp(
		String name,
		long gewicht,
		long energieverbraucha,
		long energieverbrauchb,
		long sichtbereiche) {
		this.name = name;
		this.gewicht = gewicht;
		this.energieVerbrauchProZeit = energieverbraucha;
		this.energieVerbrauchProScan = energieverbrauchb;
		this.sichtbereiche = sichtbereiche;
                sensoren.add(this);
	}

	/**Gibt das Gewicht dieses Sensortypen zur&uuml;ck
         *@return das Gewicht dieses Sensortypen
         */
        public long getgewicht() {
		return gewicht;
	}

        /**Setzt das Gewicht dieses Sensortypen
         *@param gewicht das neue Gewicht dieses Sensortypen
         */
	public void setgewicht(long gewicht) {
		this.gewicht = gewicht;
	}

	/**Gibt den Energieverbrach pro Zeit zur&uuml;ck
         *@return der Energieverbrauch pro Zeit
         */
        public long getEnergieVerbrauchProZeit() {
		return energieVerbrauchProZeit;
	}

	/**Setzt den Energieverbrauch pro Zeit des Sensortypen
         *@param energieverbraucha der neue Energieverbrauch pro Zeit dieses
         *Sensortypen
         */
        public void setEnergieVerbrauchProZeit(long energieverbraucha) {
		this.energieVerbrauchProZeit = energieverbraucha;
	}

	/**Gibt den Energieverbrach pro Scan zur&uuml;ck
         *@return der Energieverbrauch pro Scan
         */
        public long getEnergieVerbrauchProScan() {
		return energieVerbrauchProScan;
	}

	/**Setzt den Energieverbrauch pro Scan des Sensortypen
         * @param energieverbrauchb der neue Energieverbrauch pro Scan dieses
         *Sensortypen
         */
        public void setEnergieVerbrauchProScan(long energieverbrauchb) {
		this.energieVerbrauchProScan = energieverbrauchb;
	}

	/**Gibt die Anzahl der vom Sensortypen verwendeten Sichtbereiche 
         *zur&uumlck;
         *@return die Anzahl der vom Sensortypen verwendeten Sichtbereiche
         */
        public long getsichtbereiche() {
		return sichtbereiche;
	}

	/**Weist einem Feld der Schablone einen Sichtbereich zu
         *@param x die x-Koordinate der Schablone
         *@param y die y-Koordinate der Schablone
         *@param sichtbereich der Sichtbereich
         */
        public void setschablone(int x, int y, int sichtbereich) {
		if (sichtbereich > sichtbereiche)
			System.out.println("Sichtbereich gibts nicht");
		else {
			schablonen[0][x][y] = sichtbereich;
		}
	}

        /*
	public void setschablone(int Richtung, int x, int y, int sichtbereich) {
		if (sichtbereich > sichtbereiche)
			System.out.println("Sichtbereich gibts nicht");
		else {
			schablonen[Richtung][x][y] = sichtbereich;
		}
	}

	public void createGedrehteSchablone() {

	}*/
        
        /**Gibt die Schablone dieses Sensortypen zur&uuml;ck.
         *@return die Schablone dieses Sensortypen
         */
	public int[][] getschablone() {
		return schablonen[0];
	}

	/*
        public int[][] getschablone(int Richtung) {
		return schablonen[Richtung];
	}*/

        /**Setzt die scandauer pro Gel&auml;ndefeld fest
         *@param gelaende Das Gel&auml;nde, f&uuml;r das die Scandauer gelten 
         *soll
         *@param dauer die Dauer f&uuml;r den Scan
         */
	public void setscandauer(Gelaende gelaende, int dauer) {
		scandauer.put(gelaende, new Integer(dauer));
	}

        /**Gibt die Dauer f&uuml;r dejn Scan einer bestimmten Gel&auml;ndeart
         *zur&uuml;ck.
         *@param gelaende Das Gel&auml;nde, f&uuml;r das die Scandauer
         *zur&uuml;ckgegeben werden soll
         *@return die Scandauer
         */
	public int getscandauer(Gelaende gelaende) {
		return ((Integer) (scandauer.get(gelaende))).intValue();
	}

        /**Bestimmt, ob ein Gel&auml;nde f&uuml;r diesen Sensor durchsichtig ist
         *@param gelaende das Gel&auml;nde, f&uuml;r das die Durchsichtiigkeit
         *       gesetzt werden soll
         *@param durchsichtig true, wenn durchichtig<br>
                              false, wenn nicht durchchsichtig
         */
	public void setdurchsichtigkeit(Gelaende gelaende, boolean durchsichtig) {
		durchsichtigkeit.put(gelaende, Boolean.valueOf(durchsichtig));
	}

	/**Gibt die Durchsichtigkeit f&uuml;r eine bestimmte Gel&auml;ndeart
         *zur&uuml;ck
         *@param gelaende das Gel&auml;nde
         *@return true, falls durchsichtig<br>
         *        false, falls nicht durchsichtig
         */
        public boolean getdurchsichtigkeit(Gelaende gelaende) {
		return ((Boolean) (durchsichtigkeit.get(gelaende))).booleanValue();
	}

	/**L&auml;dt einen Sensortyp anhand seiner ID aus der Datenbank
	 * @param sid Die Datenbank ID des Sensors
	 * @return der geladene Sensortyp
	 */
	public static SensorTyp getSensorTyp(int sid) {
		Sql sql = new Sql();
		ResultSet rs =
			sql.select(
				"SELECT *\n" + "FROM sensor\n" + "WHERE sid = " + sid + ";");

		SensorTyp ret = null;
		try {
			rs.first();
			String name = rs.getString("name");
			Enumeration enum = SensorTyp.sensoren.elements();
			while (enum.hasMoreElements()) {
				SensorTyp st = (SensorTyp) enum.nextElement();
				if (st.name.equals(name)) {
					return st;
				}
			}
			long gewicht = rs.getLong("gewicht");
			long energieverbraucha = rs.getLong("grundenergie");
			long energieverbrauchb = rs.getLong("scanenergie");
			long sichtbereiche = rs.getInt("anzahlebenen");
			ret =
				new SensorTyp(
					name,
					gewicht,
					energieverbraucha,
					energieverbrauchb,
					sichtbereiche);
			//Durchsichtigkeit und Scandauer ziehen:
			rs =
				sql.select(
					"SELECT d.scandauer scandauer, d.durchsichtigkeit durchsichtigkeit, g.name name\n"
						+ "FROM durchsichtigkeit d, gelaende g\n"
						+ "WHERE (sid = "
						+ sid
						+ ")\n"
						+ "	AND g.gid = d.gid"
						+ ";");
			rs.beforeFirst();

			while (rs.next()) {
				String gelaendeName = rs.getString("name");
				System.out.println(gelaendeName);
				Gelaende gt = Gelaende.getgelaende(gelaendeName);
				if (gt != null) {
					ret.durchsichtigkeit.put(
						gt,
						Boolean.valueOf(rs.getString("durchsichtigkeit")));
					ret.scandauer.put(gt, new Integer(rs.getInt("scandauer")));
				}
			}

			rs.close();
			rs =
				sql.select(
					"SELECT x, y, sichtbereich\n"
						+ "FROM schablonenkachel\n"
						+ "WHERE sid ="
						+ sid
						+ ";");

			rs.beforeFirst();
			while (rs.next()) {
				int x = rs.getInt("x");
				int y = rs.getInt("y");
				int sichtbereich = rs.getInt("sichtbereich");
				ret.schablonen[NORMAL][x][y] = sichtbereich;
			}
			rs.close();
		} catch (SQLException e) {
			e.printStackTrace();
		}
		return ret;
	}
	/*
        public static void log(String message) {
		System.out.println("SensorTyp: " + message);
	}*/

	/*Gibt den Namen des Sensortypen zur&uuml;ck.
         *@return der Name des Sensortypen
         */
        public String getName() {
		return name;
	}
        
        /*Gibt den Namen des Sensortypen zur&uuml;ck.
         *@return der Name des Sensortypen
         */
        public String toString() {
            return getName();
        }

}
