package editor;

import java.util.Vector;
import java.sql.*;
import java.awt.*;
import java.util.Enumeration;
import gameserver.Roboter;
/**
 * In dieser Klasse werden alle Daten ber das Spielfeld gespeichert, auerdem
 * enthlt sie eine Methode um das Spielfeld zu malen
 */

public class Spielfeld
    extends Canvas {

  private Sql db = new Sql();
  private Sql db2 = new Sql();
  private int zoom = 100;
  private boolean mitfog = false;  // die mit... Variablen zeigen an, ob die jeweils beschriebene Komponente beim malen mit ausgegeben wird
  private boolean mitgelaende = true;
  private boolean mitrobbis = true;
  private boolean mithoehen = true;
  private boolean mitminen = true;
  private String name;
  private int laenge;
  private int breite;
  private int spid;
  private boolean[][] fogged; // wenn true, dann wird Feld schwarz angezeigt
  private Gelaende[][] gelaende; // hier sind die Gelndearten an ihren Positionen gespeihert
  private String[] sensornamen;
  private int[][] hoehen; // hier stehen die Hhen an ihre jeweiligen Position
  private Mine[][] minen; // hier steht wo die mienen sind
  private String meldungen[][][][]; // in diesem Array werden alle Sensormeldungen gespeichert abhngig von [x][y][sensornummer][ebene]
  private Vector roboter = new Vector(); //hier sind alle Roboter, die sich auf dem Spielfeld befinden
  private static Vector spielfelder = new Vector(); //Container fr alle Spielfelder

  /**
   * Konstruktor fr ein zu nderndes Spielfeld
   * @param name Name des betreffenden Spielfeldes
   */
  public Spielfeld(String name) {
    this.name = new String(name);
    //laden der Daten aus der Datenbank
    ResultSet result =
        db.select("select * from spielfeld where name='" + name + "'");
    try {
      result.next();
      spid = result.getInt("spid");
      laenge = result.getInt("laenge");
      breite = result.getInt("breite");
    }
    catch (SQLException ex) {
      System.out.println(ex);
    }
    gelaende = new Gelaende[breite][laenge];
    hoehen = new int[breite][laenge];
    minen = new Mine[breite][laenge];
    fogged = new boolean[breite][laenge];

    ResultSet kresult =
        db.select(
        "select gelaende.gid, laenge, breite, x,y,gelaende.name as gelaende, kachel.hoehe from kachel, gelaende where spid='"
        + spid
        + "' and gelaende.gid=kachel.gid");

    int x, y;
    Gelaende g;
    try {
      while (kresult.next()) {
        x = kresult.getInt("x");
        y = kresult.getInt("y");

        if (Gelaende.getgelaende(kresult.getString("gelaende"))
            == null) {
          gelaende[x][y] =
              new Gelaende(kresult.getString("gelaende"));
        }
        else {
          gelaende[x][y] =
              Gelaende.getgelaende(kresult.getString("gelaende"));
        }
        hoehen[x][y] = kresult.getInt("hoehe");
        if (kresult.getInt("laenge") > 1
            || kresult.getInt("breite") > 1) {
          for (int i = 0; i < kresult.getInt("breite"); i++) {
            for (int j = 0; j < kresult.getInt("laenge"); j++) {
              hoehen[x + i][y + j] = kresult.getInt("hoehe");
            }
          }

        }
      }

    }
    catch (SQLException ex) {
      System.out.println(ex);
    }

    ResultSet mresult =
        db.select(
        "select x,y,name from kachel,mine where spid='"
        + spid
        + "' and mine.mid=kachel.mid");

    try {
      while (mresult.next()) {
        x = mresult.getInt("x");
        y = mresult.getInt("y");
        if (Mine.getmine(mresult.getString("name")) == null) {
          minen[x][y] = new Mine(mresult.getString("name"));
        }
        else {
          minen[x][y] = Mine.getmine(mresult.getString("name"));
        }

      }

    }
    catch (SQLException ex) {
      System.out.println(ex);
    }
    result = db.select("SELECT count( * ) as anzahl FROM sensor");
    int anzsensoren = 0;
    try {
      result.next();
      anzsensoren = result.getInt("anzahl");
    }
    catch (SQLException ex1) {
      System.out.println(ex1);
    }
    result = db.select("SELECT max(anzahlebenen)as anzahl FROM sensor");

    try {
      result.next();
      meldungen =
          new String[breite][laenge][anzsensoren][result.getInt(
          "anzahl")];
    }
    catch (SQLException ex2) {
      System.out.println(ex2);
    }
    sensornamen = new String[anzsensoren];
    ResultSet sresult;
    sresult = db2.select("select sid, name, anzahlebenen from sensor");
    int zaehl;
    for (y = 0; y < laenge; y++) {
      for (x = 0; x < breite; x++) {
        if ( (x == 10) && (y == 5)) {
        }
        try {
          sresult.beforeFirst();
        }
        catch (SQLException ex4) {
          System.out.println("beforefirst" + ex4);
        }
        zaehl = 0;
        try {

          while (sresult.next()) {
            for (int i = 0;
                 i < sresult.getInt("anzahlebenen");
                 i++) {
              if (gelaende[x][y] != null) {
                if (minen[x][y] == null) {
                  result =
                      db.select(
                      "select meldung from sensormeldung, gelaende where sensormeldung.gid=gelaende.gid and name='"
                      + gelaende[x][y].getname()
                      + "'and mid=''and sensorebene='"
                      + (i + 1)
                      + "'and sid='"
                      + sresult.getInt("sid")
                      + "'");
                }
                else {
                  result =
                      db.select(
                      "select meldung from sensormeldung, gelaende, mine where sensormeldung.gid=gelaende.gid and mine.mid=sensormeldung.mid and gelaende.name='"
                      + gelaende[x][y].getname()
                      + "'and mine.name='"
                      + minen[x][y].getname()
                      + "' and sensorebene='"
                      + (i + 1)
                      + "'and sid='"
                      + sresult.getInt("sid")
                      + "'");
                }
                result.next();
                meldungen[x][y][zaehl][i] =
                    result.getString("meldung");

                //TODO lschen:
                if ( (x == 10) && (y == 5)) {
                  System.out.println(
                      "SpielfeldInit++: "
                      + meldungen[x][y][zaehl][i]
                      + ", "
                      + i
                      + ", "
                      + sresult.getInt("sid"));
                  System.out.println();
                }

                result.close();

              }
              else {
                System.out.println(x + ", " + y);
              }
            }
            if (sensornamen[zaehl] == null) {
              sensornamen[zaehl] = sresult.getString("name");
              System.out.println("" + zaehl + sensornamen[zaehl]);
            }
            zaehl++;
          }
        }
        catch (SQLException ex3) {
          System.out.println(ex3);
        }
      }
    }
    spielfelder.add(this);
    for(x=0; x<breite; x++){
      for(y=0; y<laenge; y++){
        fogged[x][y]=true;
      }
    }
  }

 /**
  * gibt ein Spielfeldobjekt aus dem Container zurck
  * @param suchname name des gesuchten Spielfeldes
  * @return gesuchtes Spielfeldobjekt
  */

  public static Spielfeld getspielfeld(String suchname) {
    Enumeration e = spielfelder.elements();
    Spielfeld sp, returner;
    returner = null;
    while (e.hasMoreElements()) {
      sp = ( (Spielfeld) e.nextElement());
      if (sp.getname().equals(suchname)) {
        returner = sp;
      }
    }
    return returner;
  }
 /**
  * gibt die Hhe einer bestimmte Spielfeldkachel zurck
  * @param x x-Koordinate der betreffenden Kachel
  * @param y y-Koordinate der betreffenden Kachel
  * @return Hhe der abgefragten Kachel
  */
  public int gethoehe(int x, int y) {
    return hoehen[x][y];
  }
/**
  * gibt das Gelnde einer bestimmte Spielfeldkachel zurck
  * @param x x-Koordinate der betreffenden Kachel
  * @param y y-Koordinate der betreffenden Kachel
  * @return Gelndeobjekt der abgefragten Kachel
 */
  public Gelaende getgelaende(int x, int y) {
    int[] returner = getroot(x, y);
    if (returner == null) {
      System.out.println("Spielfeld: " + x + ", " + y);
    }
    else {
      System.out.println("Returner: " + returner[0] + ", " + returner[1]);
    }
    return gelaende[returner[0]][returner[1]];
  }

  /**
  * gibt die Mine einer bestimmte Spielfeldkachel zurck
  * @param x x-Koordinate der betreffenden Kachel
  * @param y y-Koordinate der betreffenden Kachel
  * @return Minenobjekt der abgefragten Kachel, wenn dort keine liegt null
   */

  public Mine getmine(int x, int y) {
    return minen[x][y];
  }

  /**
   * setzt die Parameter fr das Aussehen der Ausgabe des Spielfeldes
   * @param g Anzeige mit oder ohne Gelnde
   * @param r Anzeige mit oder ohne Roboter
   * @param h Anzeige mit oder ohne Hhen
   * @param m Anzeige mit oder ohne Minen
   */

  public void setmit(boolean g, boolean r, boolean h, boolean m) {
    mitgelaende = g;
    mitrobbis = r;
    mithoehen = h;
    mitminen = m;
    repaint();
  }

 /**
  * malt das Spielfeld
  * @param g
  */

  public void paint(Graphics g) {
    int i = 0;
    for (i = 0; i <= laenge; i++) { // Horizontale Linien
      g.drawLine(1, i * (zoom / 5), (zoom / 5) * breite, i * (zoom / 5));
    }
    for (i = 0; i <= breite; i++) { // Vertikale Linien
      g.drawLine(i * (zoom / 5), 1, i * (zoom / 5), (zoom / 5) * laenge);
    }
    //boolean fog=false;
    if (mitgelaende) {
      for (int y = 0; y < laenge; y++) {
        for (int x = 0; x < breite; x++) {
          //if (mitfog && fogged[x][y])fog=true;
          if (gelaende[x][y] != null && !(mitfog && fogged[x][y])) {
            int b = gelaende[x][y].getbreite();
            int l = gelaende[x][y].getlaenge();
            int groesse = zoom / 5;
            if (gelaende[x][y] != null) {
              Image img = gelaende[x][y].getbild();
              g.drawImage(
                  img,
                  x * groesse,
                  y * groesse,
                  groesse * b,
                  groesse * l,
                  this);
            }

          }
        }

      }
    }
    //fog=false;
    if (mitminen) {
      for (int y = 0; y < laenge; y++) {
        for (int x = 0; x < breite; x++) {
          //if (mitfog && fogged[x][y])fog=true;
          if (minen[x][y] != null && !(mitfog && fogged[x][y])) {
            int groesse = zoom / 5;
            Image img = minen[x][y].getbild();
            g.drawImage(
                img,
                x * groesse,
                y * groesse,
                groesse,
                groesse,
                this);
          }
        }

      }
    }
    if (mithoehen) {
      for (int y = 0; y < laenge; y++) {
        for (int x = 0; x < breite; x++) {
          if (! (mitfog && fogged[x][y])) {
            g.drawString(
                "" + hoehen[x][y],
                x * zoom / 5 + 5,
                y * zoom / 5 + 13);

          }
        }

      }
    }
    if (mitrobbis) {
      Enumeration e;
      e = roboter.elements();
      int groesse = zoom / 5;
      while (e.hasMoreElements()) {
        Roboter robbi = (Roboter) e.nextElement();
        Image img = robbi.getbild();
        int x = robbi.getX();
        int y = robbi.getY();
        if (!(mitfog && fogged[x][y])){
          g.drawImage(
              img,
              x * groesse,
              y * groesse,
              groesse,
              groesse,
              this);
        }
      }

    }

  }

  /**
   * setzt den Zoomfaktor
   * @param z neuer Zoomfaktor
   */

  public void setzoom(int z) {
    zoom = z;
    repaint();

  }

  /**
   * gibt eine Sensormeldung zurck
   * @param sensorname Name des Sensors mit dem gescannt wird
   * @param ebene  Sensorebene mit der gescannt wird
   * @param x      x-Koordinate der Kachel, die gescannt wird
   * @param x      y-Koordinate der Kachel, die gescannt wird
   * @return       der gescannte Wert
   */

  public String getSensormeldung(
      String sensorname,
      int ebene,
      int x,
      int y) {
    ebene -= 1; // Weil 0 keine Ebene ist und der Konstruktor #&!#/
    int sensornummer = 0;
    for (int i = 0; i < sensornamen.length; i++) {
      if (sensornamen[i].equals(sensorname)) {
        sensornummer = i;
      }
    }
    if (gelaende[x][y] == null) {
      int[] root = getroot(x, y);
      x = root[0];
      y = root[1];
    }
    return meldungen[x][y][sensornummer][ebene];
  }
  /**
   * gibt den Namen des Spielfeldes zurck
   * @return Name des Spielfeldes
   */
  public String getname() {
    return new String(name);
  }

    /**
     * fgt einen Roboter hinzu
     * @param r das hinzuzufgende Roboterobjekt
     */
  public void addroboter(Roboter r) {
    roboter.add(r);
  }
  /**
   * entfernt einen Roboter
   * @param r zu entfernendes Roboterobjekt
   */
  public void removeroboter(Roboter r) {
    roboter.remove(r);
  }

  /**
   * gibt die Lnge des Spielfeldes zurck
   * @return Spielfeldlnge
   */
  public int getlaenge() {
    return this.laenge;
  }
  /**
   * gibt die Breite des Spielfeldes zurck
   * @return Spielfeldbreite
   */
  public int getbreite() {
    return this.breite;
  }

  /**
   * schaltet den fog of war fr eine bestimmte Kachel an oder ab
   * @param x  x-Koordinate des betreffenden Feldes
   * @param y  y-Koordinate des betreffenden Feldes
   * @param wert der Wert auf den der Nebel dieser Kachel gesetzt werden soll
   */
  public void setfog(int x, int y, boolean wert) {
    fogged[x][y] = wert;
  }
 /**
  * sagt, ob dies Feld durch den Fog of War ausgeblendet ist oder nicht
  * @param x    x-Koordinate des betreffenden Feldes
  * @param y    y-Koordinate des betreffenden Feldes
  * @return     true wenn dieses Feld durch den Nebel versteckt wird, sonst false
  */
  public boolean getfog(int x, int y) {
    return fogged[x][y];
  }
  /**
   * schaltet den fog of war an oder ab
   * @param wert bei true werden alle vernebelten Felder nicht angezeigt
   */

  public void setmitfog(boolean wert){
    mitfog=wert;
  }

 /**
  * gibt alle Roboter auf diesem Spielfeld zurck
  * @return die Roboterobjekte, welche sich auf diesem Spielfeld befinden
  */
  public Roboter[] getroboter() {
    Roboter[] ret = new Roboter[roboter.size()];
    for (int i = 0; i < roboter.size(); i++) {
      ret[i] = (Roboter) roboter.get(i);
    }

    return ret;
  }

  /**
   * findet die linke obere Ecke eines Objektes, welche groer als 1*1 Kacheln ist
   * und sich u. a. bei den Koordinaten x, y befindet
   * @param x  betreffende x-Koordinate
   * @param y  betreffende y-Koordinate
   * @return  der erste Wert ist der X-Wert der linken oberen Ecke, der zweite Wert im Arry der y-Wert
   */
  public int[] getroot(
      int x,
      int y) { //sucht zu einer Koordinate das Feld auf dem das Objekt steht (bei groen Gelndetypen interessant)
    int[] returner = new int[2];
    int xroot, yroot = 0;
    int i = 0;
    boolean error = false;
    //Immer in Winkeln suchen: erst links vom Objekt, dann oben. Winkel vergrern.
    while (!error) {
      //links suchen:
      if (x - i >= 0) {
        int xSuche = x - i;
        for (int j = 0; j <= i; j++) {
          int ySuche = y - j;
          if (ySuche >= 0) {
            Gelaende g = gelaende[xSuche][ySuche];
            if ( (g != null)
                && (g.getbreite() >= i + 1)
                && (g.getlaenge() >= j + 1)) {
              returner[0] = xSuche;
              returner[1] = ySuche;
              return returner;
            }
          }
        }
      }
      else {
        error = true;
        //oben suchen:
      }
      if (y - i >= 0) {
        error = false;
        int ySuche = y - i;
        for (int j = 0; j < i; j++) {
          int xSuche = x - j;
          if (xSuche >= 0) {
            Gelaende g = gelaende[xSuche][ySuche];
            if ( (g != null)
                && (g.getlaenge() >= i + 1)
                && (g.getbreite() >= j + 1)) {
              returner[0] = xSuche;
              returner[1] = ySuche;
              return returner;
            }
          }
        }
      }
      i++;
    }
    return null; //Bsen Fehler erzeugen um Fehlersuche zu ermglichen :-)
  }
 /**
  * gibt die lnge des Spielfeldes zurck
  * @return Spielfeldlnge
  */
  public int getLaenge() {
    return laenge;
  }
  /**
  * gibt die Breite des Spielfeldes zurck
  * @return Spielfeldbreite
  */
  public int getBreite() {
    return breite;
  }
 //Main-methode zu Testzwecken
  public static void main(String args[]) {
    Spielfeld sp = new Spielfeld("klein");
  }
 /**
  * gibt die Objekthhe (0-2) des Objektes an der Position x, y an
  * @param x  betreffende x-Koordinate
  * @param y  betreffende y-Koordinate
  * @return  Objekthhe (0-2)
  */
  public int getObjektHoehe(int x, int y) {
    int[] root = getroot(x, y);
    return gelaende[root[0]][root[1]].gethoehe();
  }

  /**
   * sucht das Roboterobjekt zu einem Roboternamen
   * @param name Name des zu suchenden Roboters
   * @return gesuchtes Roboterobjekt
   */

  public Roboter getRoboterByName(String name) {
    Roboter r = null;
    for (int i = 0; i < roboter.size(); i++) {
      if ( ( (Roboter) roboter.get(i)).getName().equals(name)) {
        r = (Roboter) roboter.get(i);
      }
    }

    return r;
  }

  /**
   * lscht eine Mine vom Spielfeld an Position x, y
   * @param x  betreffende x-Koordinate
   * @param y  betreffende y-Koordinate
   */
  public void deleteMine(int x, int y) {
    minen[x][y] = null;
  }

  /**
   * gibt zurck ob an der betreffenden Stelle ein Roboter steht
   * @param atX  zu berprfenden x-Koordinate
   * @param atY  zu berprfenden y-Koordinate
   * @return true, wenn auf Kachel x, y ein Roboter steht, sonst false
   */

  public boolean isRoboterAt(int atX, int atY) {
    Enumeration enum = roboter.elements();
    while (enum.hasMoreElements()) {
      Roboter robby = (Roboter) enum.nextElement();
      if ( (robby.getX() == atX) && (robby.getY() == atY)) {
        return true;
      }
    }
    return false;
  }
  /**
   * entfernt einen Roboter vom Spielfeld
   * @param robby zu entfernender Roboter
   */
  public void deleteRoboter(Roboter robby) {
    roboter.remove(robby);

  }

  /**
   * zeichnet das Spielfeld neu
   * @param g
   */
  public void update(Graphics g) {
    // double buffering
    Image img = createImage(getWidth(), getHeight());
    // weggelassen Malen eines neuen Hintergrundes
    Graphics g1 = img.getGraphics();
    paint(g1);
    g.drawImage(img, 0, 0, this);

  }

}
