package editor;

import java.sql.*;
/**
 * Diese Klasse kapselt den Zugriff des Programmes auf die Datenbank
 */
//HINWEIS: die anzupassenden Zugangsdaten befinden sich in den Zeilen 27-29
public class Sql {

  private Connection dbConn;
  private Statement sqlStmt;
  private ResultSet rSet;

  /**
   * Dieser Konstruktor stellt die Verbindung zur MySql-Datenbank her
   */
  public Sql() {
    try {
      Class.forName("com.mysql.jdbc.Driver");
    }
    catch (Exception e) {
      System.out.println("Fehler beim JDBC-Treiber laden " + e);
      return;
    }
    try {
      //die Folgenden Werte mssen je nach Rechner angepasst werden
      String URL = "jdbc:mysql://localhost/editor";
      dbConn = DriverManager.getConnection(URL, "hf", "mysql");
      sqlStmt = dbConn.createStatement();
    }
    catch (Exception e) {
      System.out.println("Fehler bei Datenbankzugriff " + e);
      return;
    }
  }
  /**
   * Select-Anfragen an die Datenbank werden ber diese Methode gekapselt
   * @param statement  das Selectstatement
   * @return  das von der Datenbank zurckgegebene Resultset
   */

  public ResultSet select(String statement) {
    try {
      System.out.println(statement);
      rSet = sqlStmt.executeQuery(statement);
      return rSet;
    }
    catch (Exception e) {
      System.out.println("Fehler im Statement " + e);
      return rSet;
    }

  }
  /**
   * diese Methode kapselt Statements an die Datenbank ohne Rckgabewert, wie insert, delete und update
   * @param statement das Statement, was an die Datenbank gesendet werden soll
   */
  public void mach(String statement) {
    try {
      String statement2 = new String(statement.replace('\\', '/'));
      System.out.println(statement2);
      sqlStmt.execute(statement2);
    }
    catch (Exception e) {
      System.out.println("Fehler im Statement " + e);
    }
  }
  /**
   * Diese Methode erstellt auf der Datenbank alle Tabellen, die zur Ausfhrung dieses Programmes bentigt werden
   */
  public void tabellenanlegen() {
    Sql db = new Sql();
    db.mach("create table sensor(" +
            "sid smallint unsigned not null auto_increment," +
            "name varchar(32)," +
            "gewicht integer(10)," +
            "grundenergie integer(10)," +
            "scanenergie integer(10)," +
            "anzahlebenen integer(10)," +
            "primary key (sid)" +
            "); ");

    db.mach("create table schablonenkachel(" +
            "sid smallint not null," +
            "x smallint not null," +
            "y smallint not null," +
            "sichtbereich smallint," +
            "primary key (x,y, sid)" +
            ");");

    db.mach("create table rszuordnung(" +
            "rid smallint not null," +
            "sid smallint not null," +
            "primary key (rid, sid)" +
            ");");

    db.mach("create table antrieb(" +
            "aid smallint unsigned not null auto_increment," +
            "name varchar(32)," +
            "gewicht integer(10)," +
            "primary key (aid)" +
            ");");

    db.mach("create table passierbarkeit(" +
            "aid smallint not null," +
            "gid smallint not null," +
            "geschwindigkeit smallint(10)," +
            "energieverbrauch smallint(10)," +
            "passierbarkeit varchar(5)," +
            "primary key (gid, aid)" +
            ");");

    db.mach("create table roboter(" +
            "rid smallint unsigned not null auto_increment," +
            "aid smallint," +
            "sendereichweite integer(10)," +
            "name varchar(32)," +
            "energievorrat integer(10)," +
            "laenge smallint," +
            "breite smallint," +
            "gewicht integer(10)," +
            "bild varchar(150)," +
            "primary key (rid)" +
            ");");

    db.mach("create table gelaende(" +
            "gid smallint unsigned not null auto_increment," +
            "name varchar(32)," +
            "bild varchar(150)," +
            "hoehe smallint," +
            "laenge smallint," +
            "breite smallint," +
            "primary key (gid)" +
            ");");

    db.mach("create table durchsichtigkeit(" +
            "sid smallint not null," +
            "gid smallint not null," +
            "scandauer smallint," +
            "durchsichtigkeit varchar(5)," +
            "primary key (gid, sid)" +
            ");");

    db.mach("create table sensormeldung(" +
            "sid smallint not null," +
            "gid smallint not null," +
            "mid smallint not null," +
            "sensorebene smallint," +
            "meldung varchar(150)," +
            "primary key (mid, gid, sid, sensorebene)" +
            ");");

    db.mach("create table spielfeld(" +
            "spid smallint unsigned not null auto_increment," +
            "name varchar(32)," +
            "laenge smallint," +
            "breite smallint," +
            "uid smallint," +
            "primary key (spid)" +
            ");");

    db.mach("create table kachel(" +
            "spid smallint not null," +
            "mid smallint," +
            "gid smallint," +
            "hoehe smallint," +
            "x smallint not null," +
            "y smallint not null," +
            "primary key (spid, x, y)" +
            ");");

    db.mach("create table mine(" +
            "mid smallint unsigned not null auto_increment," +
            "name varchar(32)," +
            "bild varchar(150)," +
            "primary key (mid)" +
            ");");

    db.mach("create table umgebung(" +
            "uid smallint unsigned not null auto_increment," +
            "uname varchar(32)," +
            "aktiv varchar(5)," +
            "primary key (uid)" +
            ");");

    db.mach("create table umgantriebz(" +
            "uid smallint not null," +
            "aid smallint not null," +
            "primary key (uid, aid)" +
            ");");

    db.mach("create table umgroboterz(" +
            "uid smallint not null," +
            "rid smallint not null," +
            "primary key (uid, rid)" +
            ");");

    db.mach("create table umgsensorz(" +
            "uid smallint not null," +
            "sid smallint not null," +
            "primary key (uid, sid)" +
            ");");

    db.mach("create table umgminez(" +
            "uid smallint not null," +
            "mid smallint not null," +
            "primary key (uid, mid)" +
            ");");

    db.mach("create table umggelaendez(" +
            "uid smallint not null," +
            "gid smallint not null," +
            "primary key (uid, gid)" +
            ");");

    //db.mach("insert into mine name values ''"); //diese Mine wird bentigt um Meldungen von Gelnde ohne Mine in den Sensormeldungen speichern zu knnen
  }
 /**
  * Diese Methode schliet diese Datenbankverbindung
  */
  public void close() {
    try {
      sqlStmt.close();
      dbConn.close();
    }
    catch (Exception e) {
      System.out.println("Fehler beim schlieen der Verbindung! " + e);
    }
  }
  // die Mainmethode dient ans Spielwiese um einzelne Statements abzuschieen
  // im Moment legt sie die Tabellenstruktur an
  public static void main(String[] args) {

    Sql db = new Sql();
    db.tabellenanlegen();

  }
}
