/*
 * Created on 25.10.2003
 */
package gameserver;

import editor.AntriebsTyp;
import editor.Gelaende;

/**Ein konkreter Antrieb, welcher an einem Roboter angebracht wird
 * 
 */
public class Antrieb {
	private AntriebsTyp typ;
	/**Erzeugt einen Antrieb
	 *@param typ der Antriebstyp des zu erzeugenden Antriebs
	 */
	public Antrieb(AntriebsTyp typ) {
		this.typ = typ;
	}

        /**Gibt die Bezeichnung des Antriebs zur&uuml;ck.
         *@return der Name des Antriebstypen
         */
	public String getName() {
		return typ.getname();
	}

        /**Gibt Antriebs auf einem bestimmten Gel&auml;nde zur&uuml;ck.
         */
	public int getSpeed(Gelaende gelaende) {
		return typ.getgeschwindigkeit(gelaende);
	}

        /**Gibt zur&uuml;ck, ob der Antrieb ein bestimmtes Gel&aum;nde passieren 
         *kann.
         *@param gelaende das Gel&auml;nde
         *@return true, falls das Gel&auml;nde passiert werden kann<br>
         *        false, falls nicht
         */
	public boolean getPassierbarkeit(Gelaende gelaende) {
		return typ.getpassierbarkeit(gelaende);

	}

    
        /**Gibt das Gewicht des Antriebs zur&uuml;ck.
         *@return das Gewicht des Antriebs
         */
        public int getGewicht(){
            return typ.getgewicht();
        }
}
