/*
 * Created on 07.11.2003
 */
package gameserver;

/**Beinhaltet Informationen ber einen Roboter
 * @author Boris
 */
public class RoboterInfo {
	private final long maxEnergieVorrat;
	private final long energieVorrat;
	private final String[] sensoren;
	private final String antrieb;
	private final String richtung;
	/**Erzeugt ein neues RoboterInfo Objekt
	 * @param maxEnergieVorrat	Der Maximale Energievorrat des Roboters
	 * @param energieVorrat		Der aktuelle Energievorrat des Roboters
	 * @param sensoren			Ein Array mit den Typbezeichnern der Sensoren
	 * @param antrieb			Der Typbezeichner des Antriebs
	 * @param richtung			Ein String, der die Richtung des Roboters enthlt (Nord, Nordwest...)
	 */
	public RoboterInfo (long maxEnergieVorrat, long energieVorrat, String[] sensoren, String antrieb, String richtung){
		this.maxEnergieVorrat = maxEnergieVorrat;
		this.energieVorrat = energieVorrat;
		this.sensoren = sensoren;
		this.antrieb = antrieb;
		this.richtung = richtung;
	}
	
	
	/**Gibt den Antriebsnamen zurck
	 * @return Der Typbezeichner des Antriebs
	 */
	public String getAntrieb() {
		return antrieb;
	}

	/**Gibt den aktuellen Energievorrat des Roboters zurck
	 * @return Der Maximale Energievorrat des Roboters
	 */
	public long getEnergieVorrat() {
		return energieVorrat;
	}

	/**Gibt den maximalen Energievorrat des Roboterobjektes zurck
	 * @return Der Maximale Energievorrat des Roboters
	 */
	public long getMaxEnergieVorrat() {
		return maxEnergieVorrat;
	}

	/**Gibt die Richtung des Roboters zurck
	 * @return Ein String, der die Richtung des Roboters enthlt (Nord, Nordwest...)
	 */
	public String getRichtung() {
		return richtung;
	}

	/**Gibt ein Array mit den Typpbezeichnern der  angebrachten Sensoren zurck
	 * @return Ein Array mit den Typbezeichnern der Sensoren
	 */
	public String[] getSensoren() {
		return sensoren;
	}

}
