package mailbox;

/**
 * Wrapper fr das Ergebnis eines Sensor-Scans, damit der Agent dann sowohl das
 * Ergebnis des Scans kennt als auch den Sensor, mit dem es generiert wurde
 * User: Standard
 * Date: 04.11.2003
 * Time: 21:55:37
 *
 */
public  class ScanResult{

    public static final String OUTOFSPIELFELD = "drauen";
    private String ivSensorName;
    private String[][] ivScanresult;

    /**
     * Default-Konstruktor
     * @param ivSensorName Name des Sensors, mit dem der Scan durchgefhrt wurde
     * @param ivScanresult Das Scanergebnis in Form eines String-Arrays mit den URLs der gescannten Objekte
     */
    public ScanResult(String ivSensorName, String[][] ivScanresult) {
        this.ivScanresult = ivScanresult;
        this.ivSensorName = ivSensorName;
    }

    /**
     * Getter fr das Scan-Ergebnis
     * @return Das Scanergebnis in Form eines String-Arrays mit den URLs der gescannten Objekte
     */
    public String[][] getIvScanresult() {
        return ivScanresult;
    }

    /**
     * Getter fr den Namen des Sensors
     * @return Name des Sensors, mit dem der Scan durchgefhrt wurde
     */
    public String getIvSensorName() {
        return ivSensorName;
    }
}
