package mailbox;


/**
 * Definition des dem Server zur Verfgung stehenden Interface fr den
 * Nachrichtenaustausch.
 *
 * User: Standard
 * Date: 26.10.2003
 * Time: 15:26:33
 *
 */
public interface ServerMailbox {

    /**
     * Abrufmethode fr Servernachrichten (FIFO-Prinzip)
     * @return Die nchste Nachricht in der Mailbox oder null, falls keine vorliegt
     */
    public Message getNextServerMessage();


    /**
     * Sendet die bergebene Nachricht in die Message-Queue als Empfnger
     * angegebenen Agenten
     * @param msg Die zu versendende Nachricht
     * @param agentID Der Empfnger
     */
    public void sendMessageToAgent(String agentID, Message msg);


    /**
     * Ermglicht dem Server, eine Nachricht an alle Agenten zu verschicken
     *
     * @param msg Die an alle  Agenten zu verteilende Nachricht
     */
    public void sendBroadcast(Message msg);


}
